/**
 * Create redux-arena proxy store
 */
import { Store, ReducersMapObject, GenericStoreEnhancer } from "redux";
import { SceneReducer } from "../types";
export declare type ReducerObject = {
    reducerKey: string;
    reducer: SceneReducer<any>;
    state?: {} | null;
};
export interface EnhancedStore<S = {}> extends Store<S> {
    addSingleReducer: (reducerObject: ReducerObject) => boolean;
    removeSingleReducer: (reducerKey: string) => boolean;
    replaceSingleReducer: (reducerObject: ReducerObject) => boolean;
    close: () => void;
    runSaga: (saga: (...params: any[]) => any) => void;
}
export default function createEnhancedStore(reducers: ReducersMapObject, initialState: any, enhencer: GenericStoreEnhancer): EnhancedStore<any>;
