/// <reference types="react" />
import { ComponentType } from "react";
import { ActionCreatorsMapObject } from "redux";
import { ActionsDict } from "./actions";
import { SceneReducer } from "./reducer";
import { CurtainState } from "../reducers";
export declare type StateDict<S, D = {}> = {
    _arenaScene: S;
    _arenaCurtain: CurtainState<S>;
    $0: S;
} & D;
export declare type PropsPicker<P extends PP, S, A extends ActionCreatorsMapObject, PP> = (stateDict: StateDict<S>, actionsDict: ActionsDict<A>) => PP;
export declare type SceneBundleOptions = {
    reducerKey?: string;
    vReducerKey?: string;
    isSceneActions?: boolean;
    isSceneReducer?: boolean;
};
export declare type SceneBundle<P extends PP, S, A extends ActionCreatorsMapObject, PP> = {
    Component: ComponentType<P>;
    state: S;
    actions: A;
    propsPicker: PropsPicker<P, S, A, PP>;
    saga?: (...params: any[]) => any;
    reducer: SceneReducer<S>;
    options?: SceneBundleOptions;
};
