import ActionTypes from "../ActionTypes";
import getCurtainInitState from "./getCurtainInitState";
function curtainReducer(state, action, bindedReducerKey) {
    switch (action.type) {
        case ActionTypes.ARENA_CURTAIN_SET_STATE:
            return Object.assign({}, state, action.state);
        case ActionTypes.ARENA_CURTAIN_REPLACE_STATE:
            return Object.assign({}, action.state);
        default:
            return state;
    }
}
export default function createCurtainReducer(bindedReducerKey) {
    return function (state, action) {
        if (state === void 0) { state = getCurtainInitState(); }
        if (bindedReducerKey === action._reducerKey) {
            state = curtainReducer(state, action, bindedReducerKey);
        }
        return state;
    };
}
