Object.defineProperty(exports, "__esModule", { value: true });
var ActionTypes_1 = require("../ActionTypes");
var getCurtainInitState_1 = require("./getCurtainInitState");
function curtainReducer(state, action, bindedReducerKey) {
    switch (action.type) {
        case ActionTypes_1.default.ARENA_CURTAIN_SET_STATE:
            return Object.assign({}, state, action.state);
        case ActionTypes_1.default.ARENA_CURTAIN_REPLACE_STATE:
            return Object.assign({}, action.state);
        default:
            return state;
    }
}
function createCurtainReducer(bindedReducerKey) {
    return function (state, action) {
        if (state === void 0) { state = getCurtainInitState_1.default(); }
        if (bindedReducerKey === action._reducerKey) {
            state = curtainReducer(state, action, bindedReducerKey);
        }
        return state;
    };
}
exports.default = createCurtainReducer;
