var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ActionTypes_1 = require("../ActionTypes");
var effects_1 = require("redux-saga/effects");
var redux_1 = require("redux");
var enhancedRedux_1 = require("../enhancedRedux");
var reducers_1 = require("../reducers");
var utils_1 = require("../../utils");
function bindActions(actions, reducerKey, dispatch, isSceneActions) {
    if (isSceneActions === false) {
        return redux_1.bindActionCreators(actions, dispatch);
    }
    else {
        return enhancedRedux_1.bindArenaActionCreators(actions, dispatch, reducerKey);
    }
}
function forkSagaWithContext(saga, ctx) {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, effects_1.setContext(ctx)];
            case 1:
                _a.sent();
                return [4 /*yield*/, effects_1.fork(saga)];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}
function buildReducerFactory(reducer, state, isSceneReducer) {
    return isSceneReducer === false
        ? function (bindingReducerKey) {
            return reducers_1.createSceneReducer(reducer, state, bindingReducerKey);
        }
        : function (bindingReducerKey) {
            return reducers_1.createSceneReducer(reducers_1.sceneReducerWrapper(reducer), state, bindingReducerKey);
        };
}
function getParentReducerKey(arenaReducerDict) {
    return (arenaReducerDict &&
        arenaReducerDict._arenaCurtain &&
        arenaReducerDict._arenaCurtain.reducerKey);
}
function sceneApplyRedux(_a) {
    var arenaReducerDict = _a.arenaReducerDict, state = _a.state, saga = _a.saga, actions = _a.actions, reducer = _a.reducer, options = _a.options;
    var curOptions, arenaStore, reducerFactory, newReducerKey, bindedActions, newArenaReducerDict, newReduxInfo, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                curOptions = options || {};
                return [4 /*yield*/, effects_1.getContext("store")];
            case 1:
                arenaStore = _c.sent();
                reducerFactory = buildReducerFactory(reducer, state, curOptions.isSceneReducer === false ? false : true);
                newReducerKey = utils_1.sceneAddReducer(arenaStore, curOptions.reducerKey, reducerFactory, state);
                bindedActions = bindActions(actions, newReducerKey, arenaStore.dispatch, curOptions.isSceneActions === false ? false : true);
                newArenaReducerDict = utils_1.buildSceneReducerDict(arenaReducerDict, newReducerKey, curOptions.vReducerKey, bindedActions);
                newReduxInfo = {
                    reducerKey: newReducerKey,
                    origArenaReducerDict: arenaReducerDict,
                    actions: actions,
                    options: curOptions,
                    saga: saga,
                    bindedActions: bindedActions,
                    arenaReducerDict: newArenaReducerDict
                };
                utils_1.addStateTreeNode(arenaStore, getParentReducerKey(newReduxInfo.arenaReducerDict), newReducerKey);
                if (!saga) return [3 /*break*/, 3];
                _b = newReduxInfo;
                return [4 /*yield*/, effects_1.fork(forkSagaWithContext, saga, {
                        arenaReducerDict: newReduxInfo.arenaReducerDict
                    })];
            case 2:
                _b.saga = _c.sent();
                _c.label = 3;
            case 3: return [2 /*return*/, newReduxInfo];
        }
    });
}
exports.sceneApplyRedux = sceneApplyRedux;
function sceneUpdateRedux(_a) {
    var arenaReducerDict = _a.arenaReducerDict, state = _a.state, saga = _a.saga, actions = _a.actions, reducer = _a.reducer, options = _a.options, curSceneBundle = _a.curSceneBundle, reduxInfo = _a.reduxInfo;
    var curOptions, newReducerKey, arenaStore, reducerFactory, newReduxInfo, oldState, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                curOptions = options || {};
                newReducerKey = reduxInfo.reducerKey;
                return [4 /*yield*/, effects_1.getContext("store")];
            case 1:
                arenaStore = _c.sent();
                reducerFactory = buildReducerFactory(reducer, state, curOptions.isSceneReducer === false ? false : true);
                newReduxInfo = Object.assign({}, reduxInfo, { options: curOptions });
                if (!(curOptions.reducerKey != null &&
                    curOptions.reducerKey !== reduxInfo.reducerKey)) return [3 /*break*/, 3];
                return [4 /*yield*/, effects_1.select(function (state) { return state[reduxInfo.reducerKey]; })];
            case 2:
                oldState = _c.sent();
                newReducerKey = utils_1.sceneAddReducer(arenaStore, curOptions.reducerKey, reducerFactory, state === curSceneBundle.state ? oldState : state);
                utils_1.addStateTreeNode(arenaStore, getParentReducerKey(newReduxInfo.arenaReducerDict), newReducerKey);
                return [3 /*break*/, 6];
            case 3:
                if (!(curOptions.reducerKey === reduxInfo.reducerKey)) return [3 /*break*/, 4];
                if (reducer !== curSceneBundle.reducer ||
                    curOptions.isSceneReducer !== reduxInfo.options.isSceneReducer) {
                    newReducerKey = utils_1.sceneReplaceReducer(arenaStore, reduxInfo.reducerKey, reducerFactory, state === curSceneBundle.state ? null : state);
                }
                else if (state !== curSceneBundle.state) {
                    arenaStore.dispatch({
                        type: ActionTypes_1.default.ARENA_SCENE_REPLACE_STATE,
                        _sceneReducerKey: newReducerKey,
                        state: state
                    });
                }
                return [3 /*break*/, 6];
            case 4:
                if (!(state !== curSceneBundle.state)) return [3 /*break*/, 6];
                return [4 /*yield*/, effects_1.put({
                        type: ActionTypes_1.default.ARENA_SCENE_REPLACE_STATE,
                        _sceneReducerKey: newReducerKey,
                        state: state
                    })];
            case 5:
                _c.sent();
                _c.label = 6;
            case 6:
                newReduxInfo.reducerKey = newReducerKey;
                if (actions !== reduxInfo.actions ||
                    curOptions.isSceneActions !== reduxInfo.options.isSceneActions) {
                    newReduxInfo.actions = actions;
                    newReduxInfo.bindedActions = bindActions(actions, newReducerKey, arenaStore.dispatch, curOptions.isSceneActions === false ? false : true);
                }
                if (newReducerKey !== reduxInfo.reducerKey ||
                    curOptions.vReducerKey !== reduxInfo.options.vReducerKey ||
                    arenaReducerDict !== reduxInfo.origArenaReducerDict) {
                    newReduxInfo.arenaReducerDict = utils_1.buildSceneReducerDict(arenaReducerDict, newReducerKey, curOptions.vReducerKey, newReduxInfo.actions);
                }
                if (!saga) return [3 /*break*/, 8];
                _b = newReduxInfo;
                return [4 /*yield*/, effects_1.fork(forkSagaWithContext, saga, {
                        arenaReducerDict: newReduxInfo.arenaReducerDict
                    })];
            case 7:
                _b.saga = _c.sent();
                _c.label = 8;
            case 8: return [2 /*return*/, newReduxInfo];
        }
    });
}
exports.sceneUpdateRedux = sceneUpdateRedux;
