Object.defineProperty(exports, "__esModule", { value: true });
var ActionTypes_1 = require("../core/ActionTypes");
function addReducer(store, reducerKey, reducerFactory) {
    var newReducerKey = reducerKey;
    if (newReducerKey != null) {
        var flag = store.addSingleReducer({
            reducerKey: newReducerKey,
            reducer: reducerFactory(newReducerKey)
        });
        if (flag === false) {
            throw new Error("Reducer key [" + newReducerKey + "] already exsit.");
        }
    }
    else {
        do {
            newReducerKey = String(Math.random()).slice(2);
            var flag = store.addSingleReducer({
                reducerKey: newReducerKey,
                reducer: reducerFactory(newReducerKey)
            });
            if (flag === false)
                newReducerKey = null;
        } while (newReducerKey == null);
    }
    return newReducerKey;
}
function sceneAddReducer(store, reducerKey, reducerFactory, state) {
    var newReducerKey = addReducer(store, reducerKey, reducerFactory);
    if (state)
        store.dispatch({
            type: ActionTypes_1.default.ARENA_SCENE_REPLACE_STATE,
            _sceneReducerKey: newReducerKey,
            state: state
        });
    return newReducerKey;
}
exports.sceneAddReducer = sceneAddReducer;
function curtainAddReducer(store, reducerKey, reducerFactory, state) {
    var newReducerKey = addReducer(store, reducerKey, reducerFactory);
    if (state)
        store.dispatch({
            type: ActionTypes_1.default.ARENA_CURTAIN_REPLACE_STATE,
            _reducerKey: newReducerKey,
            state: state
        });
    return newReducerKey;
}
exports.curtainAddReducer = curtainAddReducer;
